import processing.serial.*;

String serialPort="COM3" ;


String inString;  // Input string from serial port:

Serial myPort;       

static final int lf = 10;  

void setup() {
  size(300, 150);
  PFont f;
  f = createFont("Arial",16,true); // Arial, 16 point, anti-aliasing on
  textFont(f,24);

   // List all the available serial ports:
  print("available ports are:") ;
  println(Serial.list());
   
  myPort = new Serial(this,serialPort, 115200,'N',8,1.0);
  //myPort.bufferUntil(lf);
  checkConnectionAndDownload() ;
  time1=millis() ;
  }

  
long time1 ;

void draw(){
 // downLoad() ;
  text("ready",10,110);
  text("used Port="+serialPort,10,50);
  if( (millis()-time1)>2000 ) { exit() ; }
  }


 
void checkConnectionAndDownload(){

  println("check connection") ;
  print("clear buffer:") ;  String buffer=getAnswer() ; println("["+buffer+"]") ;
  RS232send("112233445567x") ; 
  print("Answer to x=") ;  
  String answer=getAnswer() ;
  println("["+answer+"]") ;
  String answer1=" <112233445567 123400000072 5567>" ;
  print("Expected   =") ;
  println("["+answer1+"]") ;
  
  
  int k=0 ;
  boolean ok=true ;
  print("check[") ;
  for(k=0 ; k<14+19 ; k++){
    print(answer.charAt(k)) ;
    if(answer.charAt(k)!=answer1.charAt(k) ) { ok=false ; break ; }
    }
  println("] end check") ;  
  if(!ok){ println("connection not ok") ;  exit() ; }  
  if(ok) { println("connection is ok!") ;  }

  downLoadAWG2() ;
 
  println("download ok") ;
  getAnswer() ;
   
  int errorCount=0 ;
  }
 
 void downLoadAWG2(){
  int nSamples=6 ; RS232send(String.format("0000000000000%04Xt",nSamples-1)) ;
  int prescaler=150 ; RS232send(String.format("0000%08Xp",prescaler-1 )) ;
  writeTable(0,4000) ;
  writeTable(1,3000) ;
  writeTable(2,2000) ;
  writeTable(3,1000) ;
  writeTable(4,0) ;
  writeTable(5,0) ;
  }
  
 
 
void downLoadAWG1(){
   int nSamples=24576;   RS232send(String.format("0000000000000%04Xt",nSamples-1)) ;
   int prescaler=1 ;   RS232send(String.format("0000%08Xp",prescaler-1 )) ;
 
   for(int k=0 ; k<nSamples ; k++){
     if((k%100)==0) { print('.') ; } 
     int nn1=5500 ;
    // int what=(int)(2048+2047*cos(32*2*PI*k/nSamples)*exp(-2*k/((float)nSamples))) ;
      int what=(int)(2048+1020*(cos(nn1*2*PI*k/nSamples)+cos((nn1+1)*2*PI*k/nSamples) )) ;
      // int what=(int)(2048+2020*(cos(2*PI*k/nSamples))) ;
     int D13=0 ; if(k>nSamples/2) { D13=1 ; }
     int D12=0 ; if(k<1200) { D12=1 ; }
     // what=(int)(2048+2047*cos(32*2*PI*k/nSamples)*exp(-2*k/((float)nSamples))) ;
     what=what+(D13<<13)+(D12<<12) ; ;
     writeTable(k,what) ;
     }
  }
  
 
  
 void writeTable(int where, int what){
    RS232send(String.format("%04X%04Xs",where,what) ) ;
   }



String getAnswer(){
  return getAnswer(10) ;
  }

String getAnswer(int maxTries){
  int timeOut ;
  String answer ;
  answer="" ;
  timeOut=0 ;
  do{
    while (myPort.available() > 0) { 
      int inByte = myPort.read();
      if(inByte>=32){ answer=answer+(char)inByte ;}
      timeOut=0 ;
      }
    try { Thread.sleep(1); } catch (Exception e) { System.out.println(e);}
    timeOut++ ;
    } while(timeOut<maxTries) ;
 // println("answer=["+answer+"]") ;
  return answer ;
  }
  




boolean isNum(char c){
  if (('0'<=c) & (c<='9')) { return true ; }
  return false ;
  }
  
int hexVal(char c){
  if (('0'<=c) & (c<='9')) { return c-'0' ; }
  if (('A'<=c) & (c<='F')) { return c-'A'+10 ; }
  if (('a'<=c) & (c<='f')) { return c-'A'+10 ; }
  return 0 ;
  }  
int One=1 ;



 
void RS232send(String s){
  if(One==1){
    myPort.write(s) ;
   // println("TX ["+s+"]") ;
  }
  else{
    for(int k=0 ; k<s.length() ; k++){
      myPort.write(s.charAt(k)) ;
      print(s.charAt(k)) ;
      try { Thread.sleep(1); } catch (Exception e) { System.out.println(e);}
      }
    println() ;
    }
  }
  